extends ../_docs-template

block vars
  - var activeLink = 'svelte';
  - var title = 'Searchbar Svelte Component | Framework7 Svelte Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-svelte
  .docs-content
    .motion-docs-page-title
      h1 Searchbar Svelte Component
      script(src="/js/motion/searchbar.js")
      f7-motion-searchbar(motion)

    p Searchbar Svelte component represents Framework7's <a href="../docs/searchbar.html">Searchbar</a> component.

    h2 Searchbar Components
    p There are following components included:
    ul
      li `Searchbar`


    h2 Searchbar Properties
    p You can pass all parameters in single `params` property or use separate props for each parameter to specify them via component attributes:
    table.params-table
      thead
        tr
          th Prop
          th Type
          th Default
          th Description
      tbody
        tr
          th(colspan="4") &lt;Searchbar&gt; properties
        tr
          td init
          td boolean
          td true
          td Initializes Searchbar
        tr
          td value
          td string<br>number
          td
          td Allows to specify Searchbar input's value. Can be useful when used with `customSearch` enabled
        tr
          td form
          td boolean
          td true
          td Main searchbar element will be used as a `form` tag instead of `div`
        tr
          td placeholder
          td string
          td "Search"
          td Input placeholder text
        tr
          td disableButton
          td boolean
          td true
          td Enables disable button
        tr
          td disableButtonText
          td string
          td Cancel
          td Disable button text
        tr
          td clearButton
          td boolean
          td true
          td Enables searchbar input clear button
        tr
          td expandable
          td boolean
          td false
          td Enables expandable searchbar
        tr
          td inline
          td boolean
          td false
          td Enables inline searchbar
        tr
          td spellcheck
          td boolean
          td
          td Sets `spellcheck` attribute on input element
        tr
          td searchContainer
          td string<br>object
          td
          td CSS selector or HTML element of list block to search
        tr
          td searchIn
          td string
          td .item-title
          td CSS selector of List View element's field where we need to search. Usually we search through element titles ('.item-title'). It is also to pass few elements for search like `'.item-title, .item-text'`
        tr
          td searchItem
          td string
          td li
          td CSS selector of single search item. If we do a search in List View, then it must be a single list element `li`
        tr
          td searchGroup
          td string
          td .list-group
          td CSS selector of group element. Used when `hideGroups` enabled to hide groups. If we do a search in List View, then it usually a list group.
        tr
          td searchGroupTitle
          td string
          td .list-group-title
          td CSS selector of group titles. Used when `hideGroupTitles` enabled to hide group titles. If we do a search in List View, then it usually a list group title.
        tr
          td foundEl
          td string<br>object
          td .searchbar-found
          td CSS selector or HTMLElement of searchbar "found" element. If not specified, searchbar will look for `.searchbar-found` element on page
        tr
          td notFoundEl
          td string<br>object
          td .searchbar-not-found
          td CSS selector or HTMLElement of searchbar "not-found" element. If not specified, searchbar will look for `.searchbar-not-found` element on page
        tr
          td backdrop
          td boolean
          td
          td Enables searchbar backdrop element. By default, disabled for inline searchbar
        tr
          td backdropEl
          td string<br>object
          td
          td CSS selector or HTMLElement of searchbar backdrop element. If not passed and  `backdrop` parameter is true then it will look for `.searchbar-backdrop` element. In case none found it will create one automatically
        tr
          td ignore
          td string
          td .searchbar-ignore
          td CSS selector for items to be ignored by searchbar and always present in search results
        tr
          td customSearch
          td boolean
          td false
          td When enabled searchbar will not search through any of list blocks specified by `search-container` and you will be able to use custom search functionality, for example, for calling external APIs with search results and for displaying them manually
        tr
          td removeDiacritics
          td boolean
          td false
          td Enable to remove/replace diacritics (á, í, ó, etc.) during search
        tr
          td hideGroupTitles
          td boolean
          td true
          td If enabled, then search will consider group titles and hide them if there are no found items right after them
        tr
          td hideGroups
          td boolean
          td true
          td If enabled, then search will consider list view groups hide them if there are no found items inside of these groups
        tr
          td outline
          td boolean
          td true
          td Adds searchbar bottom thin border (hairline) for iOS theme

    h2 Searchbar Methods
    table.methods-table
      tr
        th(colspan="2") &lt;Searchbar&gt; methods
      tr
        td .search(<span>query</span>)
        td Force searchbar to search passed query
      tr
        td .enable()
        td Enable/activate searchbar
      tr
        td .disable()
        td Disable/deactivate searchbar
      tr
        td .toggle()
        td Toggle searchbar
      tr
        td .clear()
        td Clear search query and update results

    h2 Searchbar Events
    table.events-table
      thead
        tr
          th Event
          th Arguments
          th Description
      tbody
        tr
          th(colspan="3") &lt;Searchbar&gt; events
        tr
          td searchbarSearch
          td <span>(searchbar, query, previousQuery)</span>
          td Event will be triggered during search (search field change). As an arguments event receives searchbar instance, search query and previous query
        tr
          td searchbarClear
          td <span>(searchbar, previousQuery)</span>
          td Event will be triggered when user clicks on Searchbar input "clear" button. As an arguments event receives searchbar instance and previous query
        tr
          td searchbarEnable
          td <span>(searchbar)</span>
          td Event will be triggered when Searchbar becomes active
        tr
          td searchbarDisable
          td <span>(searchbar)</span>
          td Event will be triggered when Searchbar becomes inactive/disabled
        tr
          td change
          td <span>(event)</span>
          td Event will be triggered when "change" event occurs on searchbar input element
        tr
          td input
          td <span>(event)</span>
          td Event will be triggered when "input" event occurs on searchbar input element
        tr
          td focus
          td <span>(event)</span>
          td Event will be triggered when "focus" event occurs on searchbar input element
        tr
          td blur
          td <span>(event)</span>
          td Event will be triggered when "blur" event occurs on searchbar input element
        tr
          td clickClear
          td <span>(event)</span>
          td Event will be triggered when user clicks on input "clear" button
        tr
          td clickDisable
          td <span>(event)</span>
          td Event will be triggered when user clicks on searchbar disable button
    h2 Searchbar Slots
    p Searchbar Svelte component has additional slots for custom elements:
    ul
      li `default` - element will be inserted as a child of `<div class="searchbar-inner">` element in the end. Same as `inner-end` slot
      li `before-inner` - element will be inserted right before `<div class="searchbar-inner">` element
      li `after-inner` - element will be inserted right after `<div class="searchbar-inner">` element
      li `inner-start` - element will be inserted as a child of `<div class="searchbar-inner">` element in the beginning
      li `inner-end` - element will be inserted as a child of `<div class="searchbar-inner">` element in the end
      li `input-wrap-start` - element will be inserted as a child of `<div class="searchbar-input-wrap">` element in the beginning
      li `input-wrap-end` - element will be inserted as a child of `<div class="searchbar-input-wrap">` element in the end
    h4 Without Slots:
    :code(lang="svelte")
      <Searchbar
        disableButtonText="Cancel"
        placeholder="Search in items"
        clearButton={true}
      />

      <!-- Renders to: -->

      <form class="searchbar">
        <div class="searchbar-inner">
          <div class="searchbar-input-wrap">
            <input type="search" placeholder="Search">
            <i class="searchbar-icon"></i>
            <span class="input-clear-button"></span>
          </div>
          <span class="searchbar-disable-button">Cancel</span>
        </div>
      </form>
    h4 With Slots:
    :code(lang="svelte")
      <Searchbar
        disableButtonText="Cancel"
        placeholder="Search in items"
        clearButton={true}
      >
        <div slot="inner-start">Inner Start</div>
        <div slot="inner-end">Inner End</div>
        <div slot="input-wrap-start">Input Wrap Start</div>
        <div slot="input-wrap-end">Input Wrap End</div>
        <div slot="before-inner">Before Inner</div>
        <div slot="after-inner">After Inner</div>
      </Searchbar>

      <!-- Renders to: -->

      <form class="searchbar">
        <div slot="before-inner">Before Inner</div>
        <div class="searchbar-inner">
          <div slot="inner-start">Inner Start</div>
          <div class="searchbar-input-wrap">
            <div slot="input-wrap-start">Input Wrap Start</div>
            <input type="search" placeholder="Search">
            <i class="searchbar-icon"></i>
            <span class="input-clear-button"></span>
            <div slot="input-wrap-end">Input Wrap End</div>
          </div>
          <span class="searchbar-disable-button">Cancel</span>
          <div slot="inner-end">Inner End</div>
        </div>
        <div slot="after-inner">After Inner</div>
      </form>

    h2 Access To Searchbar Instance
    p If you use automatic initalization to init Searchbar (with `init={true}` prop) and need to use Searchbar API you can access its initialized instance by calling `.instance()` component's method. For example:
    ```svelte
      <Searchbar bind:this={component}>...</Searchbar>

      <script>
        let component;

        // to get instance in some method
        component.instance()
      </script>
    ```


    h2 Examples
    h4 Usual Searchbar
    +examplePreview('svelte', 'searchbar.svelte', 'searchbar')


    h4 Expandable Searchbar
    +examplePreview('svelte', 'searchbar-expandable.svelte', 'searchbar-expandable')
